
#include <windows.h>
#include <math.h> // sqrt and fabs
#include "avisynth.h"

class Technicolor : public GenericVideoFilter{
	const char* channel;
public:
	Technicolor(PClip _child, const char* _channel, IScriptEnvironment* env);
	~Technicolor();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

class Sepia : public GenericVideoFilter{
	int color;
	const char* mode;
public:
	Sepia(PClip _child, int _color, const char* _mode, IScriptEnvironment* env);
	~Sepia();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
private:
	int U, V;
};

class Colorize : public GenericVideoFilter{
	int color;
	bool scale;
public:
	Colorize(PClip _child, int _color, bool _scale, IScriptEnvironment* env);
	~Colorize();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
private:
	int luma, U, V;
};

class Posterize : public GenericVideoFilter{
	int pbits;
public:
	Posterize(PClip _child, int _color, IScriptEnvironment* env);
	~Posterize();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};
