
/*****************************************************
 *******   Colorspace Single-Byte Conversions   ******
 ****************************************************/

/*
__inline void YUV2RGB(REAL y, REAL u, REAL v, REAL *b, REAL *g, REAL *r) 
{
  const REAL crv = 1.5960f;
  const REAL cgv = 0.8129f;
  const REAL cgu = 0.3917f;
  const REAL cbv = 0.0002f;
  const REAL cbu = 2.0172f;

  REAL scaled_y = (y - 16) * 1.1644f;
  u -= 128.0f;
  v -= 128.0f;
  // no clamping between [0,255]
  *b = REAL(scaled_y + u * cbu - v * cbv);
  *g = REAL(scaled_y - u * cgu - v * cgv);
  *r = REAL(scaled_y + v * crv);
}
*/

inline int RGB2YUV(int rgb)
{
  const double cyb = double(0.1140*219/255);
  const double cyg = double(0.5870*219/255);
  const double cyr = double(0.2990*219/255);
  const double cvb = double(0.0813*224/255);
  const double cvg = double(0.4187*224/255);
  const double cvr = double(0.5000*224/255);
  const double cub = double(0.5000*224/255);
  const double cug = double(0.3313*224/255);
  const double cur = double(0.1687*224/255);

  int b = rgb&255;
  int g = (rgb>>8)&255;
  int r = (rgb>>16)&255;

  int y = int(cyb*b + cyg*g + cyr*r + 16.5); 
  int v = int(- cvb*b - cvg*g + cvr*r + 128.5);
  int u = int(cub*b - cug*g - cur*r + 128.5);

  return (y*256+u)*256+v;
}
